/**
 * Copyright (c) 2012-2013, Tomasz Kaczmarzyk.
 *
 * This file is part of BeanDiff.
 *
 * BeanDiff is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * BeanDiff is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with BeanDiff; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.beandiff.core.model

import java.io.StringReader
import org.beandiff.support.ClassDictionary


object Property {

  def apply(propStr: String): Property = {
    val path = new PathParser().parsePath(propStr)
    if (path.depth != 1)
      throw new IllegalArgumentException("not a single property: " + propStr)
    else
      path.head
  }
}

trait Property {
  
  def get(target: Any): Option[Any]
  
  def setValue(target: Any, value: Any)
  
  def mkString: String
  
  def mkString(elemToStrDict: ClassDictionary[(Any => String)]): String = mkString
}